﻿
Imports System.Data
Imports System.Data.SqlClient


Public Class Form1
    Private Const ConnectionString As String = "Data Source=.\SQL2017;Initial Catalog=AjaxSamples;Integrated Security = true"
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        'Fetch the data from Database.
        dataGridView1.DataSource = Me.GetData("SELECT CustomerId, Name FROM Customers")

        dataGridView1.AllowUserToAddRows = False

        'Add a ComboBox Column to the DataGridView.
        Dim comboBoxColumn As DataGridViewComboBoxColumn = New DataGridViewComboBoxColumn
        comboBoxColumn.HeaderText = "Country"
        comboBoxColumn.Width = 100
        comboBoxColumn.Name = "comboBoxColumn"
        dataGridView1.Columns.Add(comboBoxColumn)

        'Loop through the DataGridView Rows.
        For Each row As DataGridViewRow In dataGridView1.Rows

            'Reference the ComboBoxCell.
            Dim comboBoxCell As DataGridViewComboBoxCell = CType(row.Cells(2), DataGridViewComboBoxCell)

            'Insert the Default Item to ComboBoxCell.
            comboBoxCell.Items.Add("Select Country")

            'Set the Default Value as the Selected Value.
            comboBoxCell.Value = "Select Country"

            'Fetch the Countries from Database.
            Dim dt As DataTable = Me.GetData("SELECT CustomerId,  Country from Customers")

            'Loop through the DataTable Rows.
            For Each drow As DataRow In dt.Rows

                'Fetch the CustomerId (Primary Key) value.

                Dim customerId As String = drow(0).ToString

                'Add the Country value to the ComboBoxCell.
                comboBoxCell.Items.Add(drow(1))

                'Except for CustomerId #3.
                If (customerId <> "3") Then

                    'Compare the value of CustomerId.
                    If (row.Cells(0).Value.ToString = customerId) Then

                        'Once CustomerId is matched, select the Country in ComboBoxCell
                        comboBoxCell.Value = drow(1)
                    End If
                End If
            Next
        Next
    End Sub

    Private Function GetData(ByVal sql As String) As DataTable
        Dim con As SqlConnection = New SqlConnection(ConnectionString)
        Dim cmd As SqlCommand = New SqlCommand(sql, con)
        cmd.CommandType = CommandType.Text
        Dim sda As SqlDataAdapter = New SqlDataAdapter(cmd)
        Dim dt As DataTable = New DataTable
        sda.Fill(dt)
        Return dt
    End Function
End Class
